#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 28)
/* from include/media/v4l2-drv.h */
/* Combine video_get_drvdata and video_devdata as this is
   used very often. */
static inline void *video_drvdata(struct file *file)
{
        return video_get_drvdata(video_devdata(file));
}
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 31)
static 
void v4l_bound_align_image(u32 *w, unsigned int wmin, unsigned int wmax,
                           unsigned int walign,
                           u32 *h, unsigned int hmin, unsigned int hmax,
                           unsigned int halign, unsigned int salign)
{
        *w &= ~((1 << walign) - 1);
        if (*w < wmin)
                *w = wmin;
        else if (*w > wmax)
                *w = wmax;
        *h &= ~((1 << halign) - 1);
        if (*h < hmin)
                *h = hmin;
        else if (*h > hmax)
                *h = hmax;
}
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 33)
static inline const char *video_device_node_name(struct video_device *vdev)
{
#if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 26)
        return dev_name(&vdev->dev);
#else
        return kobject_name(&vdev->dev->kobj);
#endif
}
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 28)
/* from include/media/v4l2-drv.h */
/* Combine video_get_drvdata and video_devdata as this is
   used very often. */
static inline void *video_drvdata(struct file *file)
{
	return video_get_drvdata(video_devdata(file));
}
#endif




#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 37)
static inline struct v4l2_subdev *compat_v4l2_i2c_new_subdev(
		struct v4l2_device *v4l2_dev, struct i2c_adapter *adapter,
		const char *client_type,
		u8 addr, const unsigned short *probe_addrs)
{
	return v4l2_i2c_new_subdev(
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 30)
		v4l2_dev, 
#endif
		adapter, client_type, client_type,
		addr
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 32)
		, probe_addrs
#endif
		);
}
#define v4l2_i2c_new_subdev compat_v4l2_i2c_new_subdev

#endif

#ifdef SNDRV_CARDS
#if LINUX_VERSION_CODE <= KERNEL_VERSION(2, 6, 29)
static inline int snd_card_create(int idx, const char *id,
                      struct module *module, int extra_size, 
		      struct snd_card **s)
{
	*s = snd_card_new(idx, id, module, extra_size);
	return *s ? 0 : -ENODEV;
}
#endif
#endif
